Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkGeneralTransform Class Reference

`#include <vtkGeneralTransform.h>`

Inheritance diagram for vtkGeneralTransform:

[legend]
Collaboration diagram for vtkGeneralTransform:

[legend]
List of all members.

## Detailed Description

allows operations on any transforms

Date:
  2002/12/26 18:24:21

Revision:
  1.40

vtkGeneralTransform is like vtkTransform and vtkPerspectiveTransform, but it will work with any vtkAbstractTransform as input. It is not as efficient as the other two, however, because arbitrary transformations cannot be concatenated by matrix multiplication. Transform concatenation is simulated by passing each input point through each transform in turn.

See also:
  vtkTransform vtkPerspectiveTransform

Created by:
  - Gobbi, David

CVS contributions (if > 5%):
  - Gobbi, David (98%)

CVS logs (CVSweb):
  - .`cxx` (`/Common/vtkGeneralTransform.cxx)`
  - .`h` (`/Common/vtkGeneralTransform.h)`

Tests:
  vtkGeneralTransform (Tests)

Definition at line 52 of file vtkGeneralTransform.h.

## Public Types
typedef vtkAbstractTransform | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | Identity ()
void | Inverse ()
void | Concatenate (vtkAbstractTransform *transform)
int | CircuitCheck (vtkAbstractTransform *transform)
vtkAbstractTransform * | MakeTransform ()
unsigned long | GetMTime ()
void | Translate (double x, double y, double z)
void | Translate (const double x[3])
void | Translate (const float x[3])
void | RotateWXYZ (double angle, double x, double y, double z)
void | RotateWXYZ (double angle, const double axis[3])
void | RotateWXYZ (double angle, const float axis[3])
void | RotateX (double angle)
void | RotateY (double angle)
void | RotateZ (double angle)
void | Scale (double x, double y, double z)
void | Scale (const double s[3])
void | Scale (const float s[3])
void | Concatenate (vtkMatrix4x4 *matrix)
void | Concatenate (const double elements[16])
void | PreMultiply ()
void | PostMultiply ()
int | GetNumberOfConcatenatedTransforms ()
vtkAbstractTransform * | GetConcatenatedTransform (int i)
void | SetInput (vtkAbstractTransform *input)
vtkAbstractTransform * | GetInput ()
int | GetInverseFlag ()
void | Push ()
void | Pop ()
void | InternalTransformPoint (const float in[3], float out[3])
void | InternalTransformPoint (const double in[3], double out[3])
void | InternalTransformDerivative (const float in[3], float out[3], float derivative[3][3])
void | InternalTransformDerivative (const double in[3], double out[3], double derivative[3][3])
## Static Public Methods
vtkGeneralTransform * | New ()
int | IsTypeOf (const char *type)
vtkGeneralTransform * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkGeneralTransform ()
| ~vtkGeneralTransform ()
void | InternalDeepCopy (vtkAbstractTransform *t)
void | InternalUpdate ()
## Protected Attributes
vtkAbstractTransform * | Input
vtkTransformConcatenation * | Concatenation
vtkTransformConcatenationStack * | Stack

## Member Typedef Documentation

typedef vtkAbstractTransform vtkGeneralTransform::Superclass

| Reimplemented from vtkAbstractTransform. Definition at line 57 of file vtkGeneralTransform.h.

## Constructor & Destructor Documentation

vtkGeneralTransform::vtkGeneralTransform | ( |  | ) | `[protected]`

vtkGeneralTransform::~vtkGeneralTransform | ( |  | ) | `[protected]`

## Member Function Documentation

vtkGeneralTransform* vtkGeneralTransform::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkGeneralTransform::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkAbstractTransform.

int vtkGeneralTransform::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkAbstractTransform.

virtual int vtkGeneralTransform::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkAbstractTransform.

vtkGeneralTransform* vtkGeneralTransform::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkAbstractTransform.

void vtkGeneralTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkAbstractTransform.

void vtkGeneralTransform::Identity | ( |  | ) | `[inline]`

| Set this transformation to the identity transformation. If the transform has an Input, then the transformation will be reset so that it is the same as the Input. Reimplemented from vtkAbstractTransform. Definition at line 63 of file vtkGeneralTransform.h. References vtkObject::Modified().

void vtkGeneralTransform::Inverse | ( |  | ) | `[inline, virtual]`

| Invert the transformation. This will also set a flag so that the transformation will use the inverse of its Input, if an Input has been set. Implements vtkAbstractTransform. Definition at line 68 of file vtkGeneralTransform.h. References vtkObject::Modified().

void vtkGeneralTransform::Translate | ( | double | x,
|  | double | y,
|  | double | z
| ) | `[inline]`

| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 73 of file vtkGeneralTransform.h.

void vtkGeneralTransform::Translate | ( | const double | x[3] | ) | `[inline]`

| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 75 of file vtkGeneralTransform.h.

void vtkGeneralTransform::Translate | ( | const float | x[3] | ) | `[inline]`

| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 76 of file vtkGeneralTransform.h.

void vtkGeneralTransform::RotateWXYZ | ( | double | angle,
|  | double | x,
|  | double | y,
|  | double | z
| ) | `[inline]`

| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around. Definition at line 84 of file vtkGeneralTransform.h.

void vtkGeneralTransform::RotateWXYZ | ( | double | angle,
|  | const double | axis[3]
| ) | `[inline]`

| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around. Definition at line 86 of file vtkGeneralTransform.h.

void vtkGeneralTransform::RotateWXYZ | ( | double | angle,
|  | const float | axis[3]
| ) | `[inline]`

| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around. Definition at line 88 of file vtkGeneralTransform.h.

void vtkGeneralTransform::RotateX | ( | double | angle | ) | `[inline]`

| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is expressed in degrees. Definition at line 96 of file vtkGeneralTransform.h.

void vtkGeneralTransform::RotateY | ( | double | angle | ) | `[inline]`

| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is expressed in degrees. Definition at line 97 of file vtkGeneralTransform.h.

void vtkGeneralTransform::RotateZ | ( | double | angle | ) | `[inline]`

| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. The angle is expressed in degrees. Definition at line 98 of file vtkGeneralTransform.h.

void vtkGeneralTransform::Scale | ( | double | x,
|  | double | y,
|  | double | z
| ) | `[inline]`

| Create a scale matrix (i.e. set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 105 of file vtkGeneralTransform.h.

void vtkGeneralTransform::Scale | ( | const double | s[3] | ) | `[inline]`

| Create a scale matrix (i.e. set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 107 of file vtkGeneralTransform.h.

void vtkGeneralTransform::Scale | ( | const float | s[3] | ) | `[inline]`

| Create a scale matrix (i.e. set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 108 of file vtkGeneralTransform.h.

void vtkGeneralTransform::Concatenate | ( | vtkMatrix4x4 * | matrix | ) | `[inline]`

| Concatenates the matrix with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 114 of file vtkGeneralTransform.h. References vtkMatrix4x4::Element.

void vtkGeneralTransform::Concatenate | ( | const double | elements[16] | ) | `[inline]`

| Concatenates the matrix with the current transformation according to PreMultiply or PostMultiply semantics. Definition at line 116 of file vtkGeneralTransform.h.

void vtkGeneralTransform::Concatenate | ( | vtkAbstractTransform * | transform | ) |

| Concatenate the specified transform with the current transformation according to PreMultiply or PostMultiply semantics. The concatenation is pipelined, meaning that if any of the transformations are changed, even after Concatenate() is called, those changes will be reflected when you call TransformPoint().

void vtkGeneralTransform::PreMultiply | ( |  | ) | `[inline]`

| Sets the internal state of the transform to PreMultiply. All subsequent operations will occur before those already represented in the current transformation. In homogeneous matrix notation, M = M*A where M is the current transformation matrix and A is the applied matrix. The default is PreMultiply. Definition at line 133 of file vtkGeneralTransform.h. References vtkObject::Modified().

void vtkGeneralTransform::PostMultiply | ( |  | ) | `[inline]`

| Sets the internal state of the transform to PostMultiply. All subsequent operations will occur after those already represented in the current transformation. In homogeneous matrix notation, M = A*M where M is the current transformation matrix and A is the applied matrix. The default is PreMultiply. Definition at line 144 of file vtkGeneralTransform.h. References vtkObject::Modified().

int vtkGeneralTransform::GetNumberOfConcatenatedTransforms | ( |  | ) | `[inline]`

| Get the total number of transformations that are linked into this one via Concatenate() operations or via SetInput(). Definition at line 152 of file vtkGeneralTransform.h.

vtkAbstractTransform* vtkGeneralTransform::GetConcatenatedTransform | ( | int | i | ) | `[inline]`

| Get one of the concatenated transformations as a vtkAbstractTransform. These transformations are applied, in series, every time the transformation of a coordinate occurs. This method is provided to make it possible to decompose a transformation into its constituents, for example to save a transformation to a file. Definition at line 163 of file vtkGeneralTransform.h.

void vtkGeneralTransform::SetInput | ( | vtkAbstractTransform * | input | ) |

| Set the input for this transformation. This will be used as the base transformation if it is set. This method allows you to build a transform pipeline: if the input is modified, then this transformation will automatically update accordingly. Note that the InverseFlag, controlled via Inverse(), determines whether this transformation will use the Input or the inverse of the Input.

vtkAbstractTransform* vtkGeneralTransform::GetInput | ( |  | ) | `[inline]`

| Set the input for this transformation. This will be used as the base transformation if it is set. This method allows you to build a transform pipeline: if the input is modified, then this transformation will automatically update accordingly. Note that the InverseFlag, controlled via Inverse(), determines whether this transformation will use the Input or the inverse of the Input. Definition at line 184 of file vtkGeneralTransform.h.

int vtkGeneralTransform::GetInverseFlag | ( |  | ) | `[inline]`

| Get the inverse flag of the transformation. This controls whether it is the Input or the inverse of the Input that is used as the base transformation. The InverseFlag is flipped every time Inverse() is called. The InverseFlag is off when a transform is first created. Definition at line 192 of file vtkGeneralTransform.h.

void vtkGeneralTransform::Push | ( |  | ) | `[inline]`

| Pushes the current transformation onto the transformation stack. Definition at line 198 of file vtkGeneralTransform.h. References vtkObject::Modified(), and vtkTransformConcatenationStack::New().

void vtkGeneralTransform::Pop | ( |  | ) | `[inline]`

| Deletes the transformation on the top of the stack and sets the top to the next transformation on the stack. Definition at line 207 of file vtkGeneralTransform.h. References vtkObject::Modified().

void vtkGeneralTransform::InternalTransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) | `[virtual]`

| This will calculate the transformation without calling Update. Meant for use only within other VTK classes. Implements vtkAbstractTransform.

void vtkGeneralTransform::InternalTransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) | `[virtual]`

| This will calculate the transformation without calling Update. Meant for use only within other VTK classes. Implements vtkAbstractTransform.

void vtkGeneralTransform::InternalTransformDerivative | ( | const float | in[3],
|  | float | out[3],
|  | float | derivative[3][3]
| ) | `[virtual]`

| This will calculate the transformation as well as its derivative without calling Update. Meant for use only within other VTK classes. Implements vtkAbstractTransform.

void vtkGeneralTransform::InternalTransformDerivative | ( | const double | in[3],
|  | double | out[3],
|  | double | derivative[3][3]
| ) | `[virtual]`

| This will calculate the transformation as well as its derivative without calling Update. Meant for use only within other VTK classes. Implements vtkAbstractTransform.

int vtkGeneralTransform::CircuitCheck | ( | vtkAbstractTransform * | transform | ) | `[virtual]`

| Check for self-reference. Will return true if concatenating with the specified transform, setting it to be our inverse, or setting it to be our input will create a circular reference. CircuitCheck is automatically called by SetInput(), SetInverse(), and Concatenate(vtkXTransform *). Avoid using this function, it is experimental. Reimplemented from vtkAbstractTransform.

vtkAbstractTransform* vtkGeneralTransform::MakeTransform | ( |  | ) | `[virtual]`

| Make another transform of the same type. Implements vtkAbstractTransform.

unsigned long vtkGeneralTransform::GetMTime | ( |  | ) | `[virtual]`

| Override GetMTime to account for input and concatenation. Reimplemented from vtkAbstractTransform.

void vtkGeneralTransform::InternalDeepCopy | ( | vtkAbstractTransform * | t | ) | `[protected, virtual]`

| Perform any subclass-specific DeepCopy. Reimplemented from vtkAbstractTransform.

void vtkGeneralTransform::InternalUpdate | ( |  | ) | `[protected, virtual]`

| Perform any subclass-specific Update. Reimplemented from vtkAbstractTransform.

## Member Data Documentation

vtkAbstractTransform* vtkGeneralTransform::Input`[protected]`

| Definition at line 249 of file vtkGeneralTransform.h.

vtkTransformConcatenation* vtkGeneralTransform::Concatenation`[protected]`

| Definition at line 250 of file vtkGeneralTransform.h.

vtkTransformConcatenationStack* vtkGeneralTransform::Stack`[protected]`

| Definition at line 251 of file vtkGeneralTransform.h.

The documentation for this class was generated from the following file:

- Common/vtkGeneralTransform.h